// Generated by Bisonc++ V2.7.0 on Wed, 25 Jan 2012 22:39:11 +0100

// $insert class.ih
#include "parser.ih"

// The FIRST element of SR arrays shown below uses `d_type', defining the
// state's type, and `d_lastIdx' containing the last element's index. If
// d_lastIdx contains the REQ_TOKEN bitflag (see below) then the state needs
// a token: if in this state d_token__ is _UNDETERMINED_, nextToken() will be
// called

// The LAST element of SR arrays uses `d_token' containing the last retrieved
// token to speed up the (linear) seach.  Except for the first element of SR
// arrays, the field `d_action' is used to determine what to do next. If
// positive, it represents the next state (used with SHIFT); if zero, it
// indicates `ACCEPT', if negative, -d_action represents the number of the
// rule to reduce to.

// `lookup()' tries to find d_token__ in the current SR array. If it fails, and
// there is no default reduction UNEXPECTED_TOKEN__ is thrown, which is then
// caught by the error-recovery function.

// The error-recovery function will pop elements off the stack until a state
// having bit flag ERR_ITEM is found. This state has a transition on _error_
// which is applied. In this _error_ state, while the current token is not a
// proper continuation, new tokens are obtained by nextToken(). If such a
// token is found, error recovery is successful and the token is
// handled according to the error state's SR table and parsing continues.
// During error recovery semantic actions are ignored.

// A state flagged with the DEF_RED flag will perform a default
// reduction if no other continuations are available for the current token.

// The ACCEPT STATE never shows a default reduction: when it is reached the
// parser returns ACCEPT(). During the grammar
// analysis phase a default reduction may have been defined, but it is
// removed during the state-definition phase.

// So:
//      s_x[] = 
//      {
//                  [_field_1_]         [_field_2_]
//
// First element:   {state-type,        idx of last element},
// Other elements:  {required token,    action to perform},
//                                      ( < 0: reduce, 
//                                          0: ACCEPT,
//                                        > 0: next state)
// Last element:    {set to d_token__,    action to perform}
//      }

// When the --thread-safe option is specified, all static data are defined as
// const. If --thread-safe is not provided, the state-tables are not defined
// as const, since the lookup() function below will modify them


namespace // anonymous
{
    char const author[] = "Frank B. Brokken (f.b.brokken@rug.nl)";

    enum 
    {
        STACK_EXPANSION = 5     // size to expand the state-stack with when
                                // full
    };

    enum ReservedTokens
    {
        PARSE_ACCEPT     = 0,   // `ACCEPT' TRANSITION
        _UNDETERMINED_   = -2,
        _EOF_            = -1,
        _error_          = 256
    };
    enum StateType       // modify statetype/data.cc when this enum changes
    {
        NORMAL,
        ERR_ITEM,
        REQ_TOKEN,
        ERR_REQ,    // ERR_ITEM | REQ_TOKEN
        DEF_RED,    // state having default reduction
        ERR_DEF,    // ERR_ITEM | DEF_RED
        REQ_DEF,    // REQ_TOKEN | DEF_RED
        ERR_REQ_DEF // ERR_ITEM | REQ_TOKEN | DEF_RED
    };    
    struct PI__     // Production Info
    {
        size_t d_nonTerm; // identification number of this production's
                            // non-terminal 
        size_t d_size;    // number of elements in this production 
    };

    struct SR__     // Shift Reduce info, see its description above
    {
        union
        {
            int _field_1_;      // initializer, allowing initializations 
                                // of the SR s_[] arrays
            int d_type;
            int d_token;
        };
        union
        {
            int _field_2_;

            int d_lastIdx;          // if negative, the state uses SHIFT
            int d_action;           // may be negative (reduce), 
                                    // postive (shift), or 0 (accept)
            size_t d_errorState;    // used with Error states
        };
    };

    // $insert staticdata
    
// Productions Info Records:
PI__ const s_productionInfo[] = 
{
     {0, 0}, // not used: reduction values are negative
     {277, 0}, // 1: commands ->  <empty>
     {277, 2}, // 2: commands ->  commands command
     {278, 1}, // 3: command ->  command_noargs
     {278, 1}, // 4: command ->  command_args
     {279, 1}, // 5: command_noargs ->  CMD_SPACE
     {279, 1}, // 6: command_noargs ->  CMD_NEWLINE
     {279, 1}, // 7: command_noargs ->  CMD_EOF
     {279, 1}, // 8: command_noargs ->  CMD_END
     {280, 6}, // 9: command_args ->  CMD_INT '(' expr ',' expr ')'
     {280, 8}, // 10: command_args ->  CMD_INT '(' expr ',' expr ',' VARIABLE ')'
     {280, 4}, // 11: command_args ->  CMD_STRING '(' STRING ')'
     {280, 4}, // 12: command_args ->  CMD_REGEX '(' STRING ')'
     {280, 4}, // 13: command_args ->  CMD_REP '(' expr ')'
     {280, 6}, // 14: command_args ->  CMD_REP '(' expr ',' command ')'
     {280, 4}, // 15: command_args ->  CMD_WHILE '(' test ')'
     {280, 6}, // 16: command_args ->  CMD_WHILE '(' test ',' command ')'
     {283, 1}, // 17: value ->  INTEGER
     {283, 1}, // 18: value ->  VARIABLE
     {284, 1}, // 19: compare ->  CMP_LT
     {284, 1}, // 20: compare ->  CMP_GT
     {284, 1}, // 21: compare ->  CMP_LE
     {284, 1}, // 22: compare ->  CMP_GE
     {284, 1}, // 23: compare ->  CMP_EQ
     {284, 1}, // 24: compare ->  CMP_NE
     {281, 1}, // 25: expr ->  term
     {281, 3}, // 26: expr ->  expr '+' term
     {281, 3}, // 27: expr ->  expr '-' term
     {285, 1}, // 28: term ->  value
     {285, 2}, // 29: term ->  '-' term
     {285, 3}, // 30: term ->  '(' expr ')'
     {285, 3}, // 31: term ->  term '*' term
     {285, 3}, // 32: term ->  term '/' term
     {285, 3}, // 33: term ->  term '%' term
     {282, 2}, // 34: test ->  '!' test
     {282, 3}, // 35: test ->  '(' test ')'
     {282, 3}, // 36: test ->  test '&' test
     {282, 3}, // 37: test ->  test '|' test
     {282, 3}, // 38: test ->  expr compare expr
     {282, 1}, // 39: test ->  TEST_EOF
     {282, 4}, // 40: test ->  TEST_MATCH '(' STRING ')'
     {286, 1}, // 41: commands_$ ->  commands
};

// State info and SR__ transitions for each state.


SR__ s_0[] =
{
    { { DEF_RED}, {  2} },            
    { {     277}, {  1} }, // commands
    { {       0}, { -1} },            
};

SR__ s_1[] =
{
    { { REQ_TOKEN}, {           14} },                  
    { {       278}, {            2} }, // command       
    { {       279}, {            3} }, // command_noargs
    { {       280}, {            4} }, // command_args  
    { {       265}, {            5} }, // CMD_SPACE     
    { {       266}, {            6} }, // CMD_NEWLINE   
    { {       267}, {            7} }, // CMD_EOF       
    { {       273}, {            8} }, // CMD_END       
    { {       268}, {            9} }, // CMD_INT       
    { {       269}, {           10} }, // CMD_STRING    
    { {       270}, {           11} }, // CMD_REGEX     
    { {       271}, {           12} }, // CMD_REP       
    { {       272}, {           13} }, // CMD_WHILE     
    { {     _EOF_}, { PARSE_ACCEPT} },                  
    { {         0}, {            0} },                  
};

SR__ s_2[] =
{
    { { DEF_RED}, {  1} }, 
    { {       0}, { -2} }, 
};

SR__ s_3[] =
{
    { { DEF_RED}, {  1} }, 
    { {       0}, { -3} }, 
};

SR__ s_4[] =
{
    { { DEF_RED}, {  1} }, 
    { {       0}, { -4} }, 
};

SR__ s_5[] =
{
    { { DEF_RED}, {  1} }, 
    { {       0}, { -5} }, 
};

SR__ s_6[] =
{
    { { DEF_RED}, {  1} }, 
    { {       0}, { -6} }, 
};

SR__ s_7[] =
{
    { { DEF_RED}, {  1} }, 
    { {       0}, { -7} }, 
};

SR__ s_8[] =
{
    { { DEF_RED}, {  1} }, 
    { {       0}, { -8} }, 
};

SR__ s_9[] =
{
    { { REQ_TOKEN}, {  2} },       
    { {        40}, { 14} }, // '('
    { {         0}, {  0} },       
};

SR__ s_10[] =
{
    { { REQ_TOKEN}, {  2} },       
    { {        40}, { 15} }, // '('
    { {         0}, {  0} },       
};

SR__ s_11[] =
{
    { { REQ_TOKEN}, {  2} },       
    { {        40}, { 16} }, // '('
    { {         0}, {  0} },       
};

SR__ s_12[] =
{
    { { REQ_TOKEN}, {  2} },       
    { {        40}, { 17} }, // '('
    { {         0}, {  0} },       
};

SR__ s_13[] =
{
    { { REQ_TOKEN}, {  2} },       
    { {        40}, { 18} }, // '('
    { {         0}, {  0} },       
};

SR__ s_14[] =
{
    { { REQ_TOKEN}, {  8} },            
    { {       281}, { 19} }, // expr    
    { {       285}, { 20} }, // term    
    { {       283}, { 21} }, // value   
    { {        45}, { 22} }, // '-'     
    { {        40}, { 23} }, // '('     
    { {       275}, { 24} }, // INTEGER 
    { {       274}, { 25} }, // VARIABLE
    { {         0}, {  0} },            
};

SR__ s_15[] =
{
    { { REQ_TOKEN}, {  2} },          
    { {       276}, { 26} }, // STRING
    { {         0}, {  0} },          
};

SR__ s_16[] =
{
    { { REQ_TOKEN}, {  2} },          
    { {       276}, { 27} }, // STRING
    { {         0}, {  0} },          
};

SR__ s_17[] =
{
    { { REQ_TOKEN}, {  8} },            
    { {       281}, { 28} }, // expr    
    { {       285}, { 20} }, // term    
    { {       283}, { 21} }, // value   
    { {        45}, { 22} }, // '-'     
    { {        40}, { 23} }, // '('     
    { {       275}, { 24} }, // INTEGER 
    { {       274}, { 25} }, // VARIABLE
    { {         0}, {  0} },            
};

SR__ s_18[] =
{
    { { REQ_TOKEN}, { 12} },              
    { {       282}, { 29} }, // test      
    { {        33}, { 30} }, // '!'       
    { {        40}, { 31} }, // '('       
    { {       281}, { 32} }, // expr      
    { {       257}, { 33} }, // TEST_EOF  
    { {       258}, { 34} }, // TEST_MATCH
    { {       285}, { 20} }, // term      
    { {       283}, { 21} }, // value     
    { {        45}, { 22} }, // '-'       
    { {       275}, { 24} }, // INTEGER   
    { {       274}, { 25} }, // VARIABLE  
    { {         0}, {  0} },              
};

SR__ s_19[] =
{
    { { REQ_TOKEN}, {  4} },       
    { {        44}, { 35} }, // ','
    { {        43}, { 36} }, // '+'
    { {        45}, { 37} }, // '-'
    { {         0}, {  0} },       
};

SR__ s_20[] =
{
    { { REQ_DEF}, {   4} },       
    { {      42}, {  38} }, // '*'
    { {      47}, {  39} }, // '/'
    { {      37}, {  40} }, // '%'
    { {       0}, { -25} },       
};

SR__ s_21[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -28} }, 
};

SR__ s_22[] =
{
    { { REQ_TOKEN}, {  7} },            
    { {       285}, { 41} }, // term    
    { {       283}, { 21} }, // value   
    { {        45}, { 22} }, // '-'     
    { {        40}, { 23} }, // '('     
    { {       275}, { 24} }, // INTEGER 
    { {       274}, { 25} }, // VARIABLE
    { {         0}, {  0} },            
};

SR__ s_23[] =
{
    { { REQ_TOKEN}, {  8} },            
    { {       281}, { 42} }, // expr    
    { {       285}, { 20} }, // term    
    { {       283}, { 21} }, // value   
    { {        45}, { 22} }, // '-'     
    { {        40}, { 23} }, // '('     
    { {       275}, { 24} }, // INTEGER 
    { {       274}, { 25} }, // VARIABLE
    { {         0}, {  0} },            
};

SR__ s_24[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -17} }, 
};

SR__ s_25[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -18} }, 
};

SR__ s_26[] =
{
    { { REQ_TOKEN}, {  2} },       
    { {        41}, { 43} }, // ')'
    { {         0}, {  0} },       
};

SR__ s_27[] =
{
    { { REQ_TOKEN}, {  2} },       
    { {        41}, { 44} }, // ')'
    { {         0}, {  0} },       
};

SR__ s_28[] =
{
    { { REQ_TOKEN}, {  5} },       
    { {        41}, { 45} }, // ')'
    { {        44}, { 46} }, // ','
    { {        43}, { 36} }, // '+'
    { {        45}, { 37} }, // '-'
    { {         0}, {  0} },       
};

SR__ s_29[] =
{
    { { REQ_TOKEN}, {  5} },       
    { {        41}, { 47} }, // ')'
    { {        44}, { 48} }, // ','
    { {        38}, { 49} }, // '&'
    { {       124}, { 50} }, // '|'
    { {         0}, {  0} },       
};

SR__ s_30[] =
{
    { { REQ_TOKEN}, { 12} },              
    { {       282}, { 51} }, // test      
    { {        33}, { 30} }, // '!'       
    { {        40}, { 31} }, // '('       
    { {       281}, { 32} }, // expr      
    { {       257}, { 33} }, // TEST_EOF  
    { {       258}, { 34} }, // TEST_MATCH
    { {       285}, { 20} }, // term      
    { {       283}, { 21} }, // value     
    { {        45}, { 22} }, // '-'       
    { {       275}, { 24} }, // INTEGER   
    { {       274}, { 25} }, // VARIABLE  
    { {         0}, {  0} },              
};

SR__ s_31[] =
{
    { { REQ_TOKEN}, { 12} },              
    { {       282}, { 52} }, // test      
    { {       281}, { 53} }, // expr      
    { {        33}, { 30} }, // '!'       
    { {        40}, { 31} }, // '('       
    { {       257}, { 33} }, // TEST_EOF  
    { {       258}, { 34} }, // TEST_MATCH
    { {       285}, { 20} }, // term      
    { {       283}, { 21} }, // value     
    { {        45}, { 22} }, // '-'       
    { {       275}, { 24} }, // INTEGER   
    { {       274}, { 25} }, // VARIABLE  
    { {         0}, {  0} },              
};

SR__ s_32[] =
{
    { { REQ_TOKEN}, { 10} },           
    { {       284}, { 54} }, // compare
    { {        43}, { 36} }, // '+'    
    { {        45}, { 37} }, // '-'    
    { {       259}, { 55} }, // CMP_LT 
    { {       260}, { 56} }, // CMP_GT 
    { {       261}, { 57} }, // CMP_LE 
    { {       262}, { 58} }, // CMP_GE 
    { {       263}, { 59} }, // CMP_EQ 
    { {       264}, { 60} }, // CMP_NE 
    { {         0}, {  0} },           
};

SR__ s_33[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -39} }, 
};

SR__ s_34[] =
{
    { { REQ_TOKEN}, {  2} },       
    { {        40}, { 61} }, // '('
    { {         0}, {  0} },       
};

SR__ s_35[] =
{
    { { REQ_TOKEN}, {  8} },            
    { {       281}, { 62} }, // expr    
    { {       285}, { 20} }, // term    
    { {       283}, { 21} }, // value   
    { {        45}, { 22} }, // '-'     
    { {        40}, { 23} }, // '('     
    { {       275}, { 24} }, // INTEGER 
    { {       274}, { 25} }, // VARIABLE
    { {         0}, {  0} },            
};

SR__ s_36[] =
{
    { { REQ_TOKEN}, {  7} },            
    { {       285}, { 63} }, // term    
    { {       283}, { 21} }, // value   
    { {        45}, { 22} }, // '-'     
    { {        40}, { 23} }, // '('     
    { {       275}, { 24} }, // INTEGER 
    { {       274}, { 25} }, // VARIABLE
    { {         0}, {  0} },            
};

SR__ s_37[] =
{
    { { REQ_TOKEN}, {  7} },            
    { {       285}, { 64} }, // term    
    { {       283}, { 21} }, // value   
    { {        45}, { 22} }, // '-'     
    { {        40}, { 23} }, // '('     
    { {       275}, { 24} }, // INTEGER 
    { {       274}, { 25} }, // VARIABLE
    { {         0}, {  0} },            
};

SR__ s_38[] =
{
    { { REQ_TOKEN}, {  7} },            
    { {       285}, { 65} }, // term    
    { {       283}, { 21} }, // value   
    { {        45}, { 22} }, // '-'     
    { {        40}, { 23} }, // '('     
    { {       275}, { 24} }, // INTEGER 
    { {       274}, { 25} }, // VARIABLE
    { {         0}, {  0} },            
};

SR__ s_39[] =
{
    { { REQ_TOKEN}, {  7} },            
    { {       285}, { 66} }, // term    
    { {       283}, { 21} }, // value   
    { {        45}, { 22} }, // '-'     
    { {        40}, { 23} }, // '('     
    { {       275}, { 24} }, // INTEGER 
    { {       274}, { 25} }, // VARIABLE
    { {         0}, {  0} },            
};

SR__ s_40[] =
{
    { { REQ_TOKEN}, {  7} },            
    { {       285}, { 67} }, // term    
    { {       283}, { 21} }, // value   
    { {        45}, { 22} }, // '-'     
    { {        40}, { 23} }, // '('     
    { {       275}, { 24} }, // INTEGER 
    { {       274}, { 25} }, // VARIABLE
    { {         0}, {  0} },            
};

SR__ s_41[] =
{
    { { REQ_DEF}, {   4} },       
    { {      42}, {  38} }, // '*'
    { {      47}, {  39} }, // '/'
    { {      37}, {  40} }, // '%'
    { {       0}, { -29} },       
};

SR__ s_42[] =
{
    { { REQ_TOKEN}, {  4} },       
    { {        41}, { 68} }, // ')'
    { {        43}, { 36} }, // '+'
    { {        45}, { 37} }, // '-'
    { {         0}, {  0} },       
};

SR__ s_43[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -11} }, 
};

SR__ s_44[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -12} }, 
};

SR__ s_45[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -13} }, 
};

SR__ s_46[] =
{
    { { REQ_TOKEN}, { 13} },                  
    { {       278}, { 69} }, // command       
    { {       279}, {  3} }, // command_noargs
    { {       280}, {  4} }, // command_args  
    { {       265}, {  5} }, // CMD_SPACE     
    { {       266}, {  6} }, // CMD_NEWLINE   
    { {       267}, {  7} }, // CMD_EOF       
    { {       273}, {  8} }, // CMD_END       
    { {       268}, {  9} }, // CMD_INT       
    { {       269}, { 10} }, // CMD_STRING    
    { {       270}, { 11} }, // CMD_REGEX     
    { {       271}, { 12} }, // CMD_REP       
    { {       272}, { 13} }, // CMD_WHILE     
    { {         0}, {  0} },                  
};

SR__ s_47[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -15} }, 
};

SR__ s_48[] =
{
    { { REQ_TOKEN}, { 13} },                  
    { {       278}, { 70} }, // command       
    { {       279}, {  3} }, // command_noargs
    { {       280}, {  4} }, // command_args  
    { {       265}, {  5} }, // CMD_SPACE     
    { {       266}, {  6} }, // CMD_NEWLINE   
    { {       267}, {  7} }, // CMD_EOF       
    { {       273}, {  8} }, // CMD_END       
    { {       268}, {  9} }, // CMD_INT       
    { {       269}, { 10} }, // CMD_STRING    
    { {       270}, { 11} }, // CMD_REGEX     
    { {       271}, { 12} }, // CMD_REP       
    { {       272}, { 13} }, // CMD_WHILE     
    { {         0}, {  0} },                  
};

SR__ s_49[] =
{
    { { REQ_TOKEN}, { 12} },              
    { {       282}, { 71} }, // test      
    { {        33}, { 30} }, // '!'       
    { {        40}, { 31} }, // '('       
    { {       281}, { 32} }, // expr      
    { {       257}, { 33} }, // TEST_EOF  
    { {       258}, { 34} }, // TEST_MATCH
    { {       285}, { 20} }, // term      
    { {       283}, { 21} }, // value     
    { {        45}, { 22} }, // '-'       
    { {       275}, { 24} }, // INTEGER   
    { {       274}, { 25} }, // VARIABLE  
    { {         0}, {  0} },              
};

SR__ s_50[] =
{
    { { REQ_TOKEN}, { 12} },              
    { {       282}, { 72} }, // test      
    { {        33}, { 30} }, // '!'       
    { {        40}, { 31} }, // '('       
    { {       281}, { 32} }, // expr      
    { {       257}, { 33} }, // TEST_EOF  
    { {       258}, { 34} }, // TEST_MATCH
    { {       285}, { 20} }, // term      
    { {       283}, { 21} }, // value     
    { {        45}, { 22} }, // '-'       
    { {       275}, { 24} }, // INTEGER   
    { {       274}, { 25} }, // VARIABLE  
    { {         0}, {  0} },              
};

SR__ s_51[] =
{
    { { REQ_DEF}, {   3} },       
    { {      38}, {  49} }, // '&'
    { {     124}, {  50} }, // '|'
    { {       0}, { -34} },       
};

SR__ s_52[] =
{
    { { REQ_TOKEN}, {  4} },       
    { {        41}, { 73} }, // ')'
    { {        38}, { 49} }, // '&'
    { {       124}, { 50} }, // '|'
    { {         0}, {  0} },       
};

SR__ s_53[] =
{
    { { REQ_TOKEN}, { 11} },           
    { {        41}, { 68} }, // ')'    
    { {       284}, { 54} }, // compare
    { {        43}, { 36} }, // '+'    
    { {        45}, { 37} }, // '-'    
    { {       259}, { 55} }, // CMP_LT 
    { {       260}, { 56} }, // CMP_GT 
    { {       261}, { 57} }, // CMP_LE 
    { {       262}, { 58} }, // CMP_GE 
    { {       263}, { 59} }, // CMP_EQ 
    { {       264}, { 60} }, // CMP_NE 
    { {         0}, {  0} },           
};

SR__ s_54[] =
{
    { { REQ_TOKEN}, {  8} },            
    { {       281}, { 74} }, // expr    
    { {       285}, { 20} }, // term    
    { {       283}, { 21} }, // value   
    { {        45}, { 22} }, // '-'     
    { {        40}, { 23} }, // '('     
    { {       275}, { 24} }, // INTEGER 
    { {       274}, { 25} }, // VARIABLE
    { {         0}, {  0} },            
};

SR__ s_55[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -19} }, 
};

SR__ s_56[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -20} }, 
};

SR__ s_57[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -21} }, 
};

SR__ s_58[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -22} }, 
};

SR__ s_59[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -23} }, 
};

SR__ s_60[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -24} }, 
};

SR__ s_61[] =
{
    { { REQ_TOKEN}, {  2} },          
    { {       276}, { 75} }, // STRING
    { {         0}, {  0} },          
};

SR__ s_62[] =
{
    { { REQ_TOKEN}, {  5} },       
    { {        41}, { 76} }, // ')'
    { {        44}, { 77} }, // ','
    { {        43}, { 36} }, // '+'
    { {        45}, { 37} }, // '-'
    { {         0}, {  0} },       
};

SR__ s_63[] =
{
    { { REQ_DEF}, {   4} },       
    { {      42}, {  38} }, // '*'
    { {      47}, {  39} }, // '/'
    { {      37}, {  40} }, // '%'
    { {       0}, { -26} },       
};

SR__ s_64[] =
{
    { { REQ_DEF}, {   4} },       
    { {      42}, {  38} }, // '*'
    { {      47}, {  39} }, // '/'
    { {      37}, {  40} }, // '%'
    { {       0}, { -27} },       
};

SR__ s_65[] =
{
    { { REQ_DEF}, {   1} }, 
    { {       0}, { -31} }, 
};

SR__ s_66[] =
{
    { { REQ_DEF}, {   1} }, 
    { {       0}, { -32} }, 
};

SR__ s_67[] =
{
    { { REQ_DEF}, {   1} }, 
    { {       0}, { -33} }, 
};

SR__ s_68[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -30} }, 
};

SR__ s_69[] =
{
    { { REQ_TOKEN}, {  2} },       
    { {        41}, { 78} }, // ')'
    { {         0}, {  0} },       
};

SR__ s_70[] =
{
    { { REQ_TOKEN}, {  2} },       
    { {        41}, { 79} }, // ')'
    { {         0}, {  0} },       
};

SR__ s_71[] =
{
    { { REQ_DEF}, {   1} }, 
    { {       0}, { -36} }, 
};

SR__ s_72[] =
{
    { { REQ_DEF}, {   1} }, 
    { {       0}, { -37} }, 
};

SR__ s_73[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -35} }, 
};

SR__ s_74[] =
{
    { { REQ_DEF}, {   3} },       
    { {      43}, {  36} }, // '+'
    { {      45}, {  37} }, // '-'
    { {       0}, { -38} },       
};

SR__ s_75[] =
{
    { { REQ_TOKEN}, {  2} },       
    { {        41}, { 80} }, // ')'
    { {         0}, {  0} },       
};

SR__ s_76[] =
{
    { { DEF_RED}, {  1} }, 
    { {       0}, { -9} }, 
};

SR__ s_77[] =
{
    { { REQ_TOKEN}, {  2} },            
    { {       274}, { 81} }, // VARIABLE
    { {         0}, {  0} },            
};

SR__ s_78[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -14} }, 
};

SR__ s_79[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -16} }, 
};

SR__ s_80[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -40} }, 
};

SR__ s_81[] =
{
    { { REQ_TOKEN}, {  2} },       
    { {        41}, { 82} }, // ')'
    { {         0}, {  0} },       
};

SR__ s_82[] =
{
    { { DEF_RED}, {   1} }, 
    { {       0}, { -10} }, 
};


// State array:
SR__ *s_state[] =
{
  s_0,  s_1,  s_2,  s_3,  s_4,  s_5,  s_6,  s_7,  s_8,  s_9,
  s_10,  s_11,  s_12,  s_13,  s_14,  s_15,  s_16,  s_17,  s_18,  s_19,
  s_20,  s_21,  s_22,  s_23,  s_24,  s_25,  s_26,  s_27,  s_28,  s_29,
  s_30,  s_31,  s_32,  s_33,  s_34,  s_35,  s_36,  s_37,  s_38,  s_39,
  s_40,  s_41,  s_42,  s_43,  s_44,  s_45,  s_46,  s_47,  s_48,  s_49,
  s_50,  s_51,  s_52,  s_53,  s_54,  s_55,  s_56,  s_57,  s_58,  s_59,
  s_60,  s_61,  s_62,  s_63,  s_64,  s_65,  s_66,  s_67,  s_68,  s_69,
  s_70,  s_71,  s_72,  s_73,  s_74,  s_75,  s_76,  s_77,  s_78,  s_79,
  s_80,  s_81,  s_82,
};

} // anonymous namespace ends



// If the parsing function call uses arguments, then provide an overloaded
// function.  The code below doesn't rely on parameters, so no arguments are
// required.  Furthermore, parse uses a function try block to allow us to do
// ACCEPT and ABORT from anywhere, even from within members called by actions,
// simply throwing the appropriate exceptions.

ParserBase::ParserBase()
:
    d_stackIdx__(-1),
    // $insert debuginit
    d_debug__(false),
    d_nErrors__(0),
    // $insert requiredtokens
    d_requiredTokens__(0),
    d_acceptedTokens__(d_requiredTokens__),
    d_token__(_UNDETERMINED_),
    d_nextToken__(_UNDETERMINED_)
{}


void ParserBase::clearin()
{
    d_token__ = d_nextToken__ = _UNDETERMINED_;
}

void ParserBase::push__(size_t state)
{
    if (static_cast<size_t>(d_stackIdx__ + 1) == d_stateStack__.size())
    {
        size_t newSize = d_stackIdx__ + STACK_EXPANSION;
        d_stateStack__.resize(newSize);
        d_valueStack__.resize(newSize);
        // $insert LTYPEresize
        d_locationStack__.resize(newSize);
    }
    ++d_stackIdx__;
    d_stateStack__[d_stackIdx__] = d_state__ = state;
    *(d_vsp__ = &d_valueStack__[d_stackIdx__]) = d_val__;
    // $insert LTYPEpush
    *(d_lsp__ = &d_locationStack__[d_stackIdx__]) = d_loc__;
}

void ParserBase::popToken__()
{
    d_token__ = d_nextToken__;

    d_val__ = d_nextVal__;
    d_nextVal__ = STYPE__();

    d_nextToken__ = _UNDETERMINED_;
}
     
void ParserBase::pushToken__(int token)
{
    d_nextToken__ = d_token__;
    d_nextVal__ = d_val__;
    d_token__ = token;
}
     
void ParserBase::pop__(size_t count)
{
    if (d_stackIdx__ < static_cast<int>(count))
    {
        ABORT();
    }

    d_stackIdx__ -= count;
    d_state__ = d_stateStack__[d_stackIdx__];
    d_vsp__ = &d_valueStack__[d_stackIdx__];
    // $insert LTYPEpop
    d_lsp__ = &d_locationStack__[d_stackIdx__];
}

inline size_t ParserBase::top__() const
{
    return d_stateStack__[d_stackIdx__];
}

void Parser::executeAction(int production)
{
    if (d_token__ != _UNDETERMINED_)
        pushToken__(d_token__);     // save an already available token

                                    // save default non-nested block $$
    if (int size = s_productionInfo[production].d_size)
        d_val__ = d_vsp__[1 - size];

    switch (production)
    {
        // $insert actioncases
        
        case 2:
#line 28 "checktestdata.y"
        {
         program.push_back(d_vsp__[0]);
        }
        break;

        case 5:
#line 40 "checktestdata.y"
        { d_val__ = parse_t(d_vsp__[0]); }
        break;

        case 6:
#line 41 "checktestdata.y"
        { d_val__ = parse_t(d_vsp__[0]); }
        break;

        case 7:
#line 42 "checktestdata.y"
        { d_val__ = parse_t(d_vsp__[0]); }
        break;

        case 8:
#line 43 "checktestdata.y"
        { d_val__ = parse_t(d_vsp__[0]); }
        break;

        case 9:
#line 47 "checktestdata.y"
        { d_val__ = parse_t(d_vsp__[-5],d_vsp__[-3],d_vsp__[-1]); }
        break;

        case 10:
#line 48 "checktestdata.y"
        { d_val__ = parse_t(d_vsp__[-7],d_vsp__[-5],d_vsp__[-3],d_vsp__[-1]); }
        break;

        case 11:
#line 49 "checktestdata.y"
        { d_val__ = parse_t(d_vsp__[-3],d_vsp__[-1]); }
        break;

        case 12:
#line 50 "checktestdata.y"
        { d_val__ = parse_t(d_vsp__[-3],d_vsp__[-1]); }
        break;

        case 13:
#line 51 "checktestdata.y"
        { d_val__ = parse_t(d_vsp__[-3],d_vsp__[-1]); }
        break;

        case 14:
#line 52 "checktestdata.y"
        { d_val__ = parse_t(d_vsp__[-5],d_vsp__[-3],d_vsp__[-1]); }
        break;

        case 15:
#line 53 "checktestdata.y"
        { d_val__ = parse_t(d_vsp__[-3],d_vsp__[-1]); }
        break;

        case 16:
#line 54 "checktestdata.y"
        { d_val__ = parse_t(d_vsp__[-5],d_vsp__[-3],d_vsp__[-1]); }
        break;

        case 25:
#line 62 "checktestdata.y"
        { d_val__ = parse_t(d_vsp__[0]); }
        break;

        case 26:
#line 63 "checktestdata.y"
        { d_val__ = parse_t('+',d_vsp__[-2],d_vsp__[0]); }
        break;

        case 27:
#line 64 "checktestdata.y"
        { d_val__ = parse_t('-',d_vsp__[-2],d_vsp__[0]); }
        break;

        case 28:
#line 68 "checktestdata.y"
        { d_val__ = parse_t(d_vsp__[0]); }
        break;

        case 29:
#line 69 "checktestdata.y"
        { d_val__ = parse_t('n',d_vsp__[0]); }
        break;

        case 30:
#line 70 "checktestdata.y"
        { d_val__ = parse_t(d_vsp__[-1]); }
        break;

        case 31:
#line 71 "checktestdata.y"
        { d_val__ = parse_t('*',d_vsp__[-2],d_vsp__[0]); }
        break;

        case 32:
#line 72 "checktestdata.y"
        { d_val__ = parse_t('/',d_vsp__[-2],d_vsp__[0]); }
        break;

        case 33:
#line 73 "checktestdata.y"
        { d_val__ = parse_t('%',d_vsp__[-2],d_vsp__[0]); }
        break;

        case 34:
#line 77 "checktestdata.y"
        { d_val__ = parse_t('!',d_vsp__[0]); }
        break;

        case 35:
#line 78 "checktestdata.y"
        { d_val__ = parse_t(d_vsp__[-1]); }
        break;

        case 36:
#line 79 "checktestdata.y"
        { d_val__ = parse_t('&',d_vsp__[-2],d_vsp__[0]); }
        break;

        case 37:
#line 80 "checktestdata.y"
        { d_val__ = parse_t('|',d_vsp__[-2],d_vsp__[0]); }
        break;

        case 38:
#line 81 "checktestdata.y"
        { d_val__ = parse_t('?',d_vsp__[-1],d_vsp__[-2],d_vsp__[0]); }
        break;

        case 39:
#line 82 "checktestdata.y"
        { d_val__ = parse_t('E'); }
        break;

        case 40:
#line 83 "checktestdata.y"
        { d_val__ = parse_t('M',d_vsp__[-1]); }
        break;

    }
}

inline void ParserBase::reduce__(PI__ const &pi)
{
    d_token__ = pi.d_nonTerm;
    pop__(pi.d_size);

}

// If d_token__ is _UNDETERMINED_ then if d_nextToken__ is _UNDETERMINED_ another
// token is obtained from lex(). Then d_nextToken__ is assigned to d_token__.
void Parser::nextToken()
{
    if (d_token__ != _UNDETERMINED_)        // no need for a token: got one
        return;                             // already

    if (d_nextToken__ != _UNDETERMINED_)
    {
        popToken__();                       // consume pending token
    }
    else
    {
        ++d_acceptedTokens__;               // accept another token (see
                                            // errorRecover())
        d_token__ = lex();
        if (d_token__ <= 0)
            d_token__ = _EOF_;
    }
    print();
}

// if the final transition is negative, then we should reduce by the rule
// given by its positive value. Note that the `recovery' parameter is only
// used with the --debug option
int Parser::lookup(bool recovery)
{
    // $insert threading
    SR__ *sr = s_state[d_state__];        // get the appropriate state-table
    int lastIdx = sr->d_lastIdx;        // sentinel-index in the SR__ array

    SR__ *lastElementPtr = sr + lastIdx;
    SR__ *elementPtr = sr + 1;            // start the search at s_xx[1]

    lastElementPtr->d_token = d_token__;// set search-token

    while (elementPtr->d_token != d_token__)
        ++elementPtr;

    if (elementPtr == lastElementPtr)   // reached the last element
    {
        if (elementPtr->d_action < 0)   // default reduction
        {
            return elementPtr->d_action;                
        }

        // No default reduction, so token not found, so error.
        throw UNEXPECTED_TOKEN__;
    }

    // not at the last element: inspect the nature of the action
    // (< 0: reduce, 0: ACCEPT, > 0: shift)

    int action = elementPtr->d_action;


    return action;
}

    // When an error has occurred, pop elements off the stack until the top
    // state has an error-item. If none is found, the default recovery
    // mode (which is to abort) is activated. 
    //
    // If EOF is encountered without being appropriate for the current state,
    // then the error recovery will fall back to the default recovery mode.
    // (i.e., parsing terminates)
void Parser::errorRecovery()
try
{
    if (d_acceptedTokens__ >= d_requiredTokens__)// only generate an error-
    {                                           // message if enough tokens 
        ++d_nErrors__;                          // were accepted. Otherwise
        error("Syntax error");                  // simply skip input

    }


    // get the error state
    while (not (s_state[top__()][0].d_type & ERR_ITEM))
    {
        pop__();
    }

    // In the error state, lookup a token allowing us to proceed.
    // Continuation may be possible following multiple reductions,
    // but eventuall a shift will be used, requiring the retrieval of
    // a terminal token. If a retrieved token doesn't match, the catch below 
    // will ensure the next token is requested in the while(true) block
    // implemented below:

    int lastToken = d_token__;                  // give the unexpected token a
                                                // chance to be processed
                                                // again.

    pushToken__(_error_);                       // specify _error_ as next token
    push__(lookup(true));                       // push the error state

    d_token__ = lastToken;                      // reactivate the unexpected
                                                // token (we're now in an
                                                // ERROR state).

    bool gotToken = true;                       // the next token is a terminal

    while (true)
    {
        try
        {
            if (s_state[d_state__]->d_type & REQ_TOKEN)
            {
                gotToken = d_token__ == _UNDETERMINED_;
                nextToken();                    // obtain next token
            }
            
            int action = lookup(true);

            if (action > 0)                 // push a new state
            {
                push__(action);
                popToken__();

                if (gotToken)
                {

                    d_acceptedTokens__ = 0;
                    return;
                }
            }
            else if (action < 0)
            {
                // no actions executed on recovery but save an already 
                // available token:
                if (d_token__ != _UNDETERMINED_)
                    pushToken__(d_token__);
 
                                            // next token is the rule's LHS
                reduce__(s_productionInfo[-action]); 
            }
            else
                ABORT();                    // abort when accepting during
                                            // error recovery
        }
        catch (...)
        {
            if (d_token__ == _EOF_)
                ABORT();                    // saw inappropriate _EOF_
                      
            popToken__();                   // failing token now skipped
        }
    }
}
catch (ErrorRecovery__)       // This is: DEFAULT_RECOVERY_MODE
{
    ABORT();
}

    // The parsing algorithm:
    // Initially, state 0 is pushed on the stack, and d_token__ as well as
    // d_nextToken__ are initialized to _UNDETERMINED_. 
    //
    // Then, in an eternal loop:
    //
    //  1. If a state does not have REQ_TOKEN no token is assigned to
    //     d_token__. If the state has REQ_TOKEN, nextToken() is called to
    //      determine d_nextToken__ and d_token__ is set to
    //     d_nextToken__. nextToken() will not call lex() unless d_nextToken__ is 
    //     _UNDETERMINED_. 
    //
    //  2. lookup() is called: 
    //     d_token__ is stored in the final element's d_token field of the
    //     state's SR_ array. 
    //
    //  3. The current token is looked up in the state's SR_ array
    //
    //  4. Depending on the result of the lookup() function the next state is
    //     shifted on the parser's stack, a reduction by some rule is applied,
    //     or the parsing function returns ACCEPT(). When a reduction is
    //     called for, any action that may have been defined for that
    //     reduction is executed.
    //
    //  5. An error occurs if d_token__ is not found, and the state has no
    //     default reduction. Error handling was described at the top of this
    //     file.

int Parser::parse()
try 
{
    push__(0);                              // initial state
    clearin();                              // clear the tokens.

    while (true)
    {
        try
        {
            if (s_state[d_state__]->d_type & REQ_TOKEN)
                nextToken();                // obtain next token


            int action = lookup(false);     // lookup d_token__ in d_state__

            if (action > 0)                 // SHIFT: push a new state
            {
                push__(action);
                popToken__();               // token processed
            }
            else if (action < 0)            // REDUCE: execute and pop.
            {
                executeAction(-action);
                                            // next token is the rule's LHS
                reduce__(s_productionInfo[-action]); 
            }
            else 
                ACCEPT();
        }
        catch (ErrorRecovery__)
        {
            errorRecovery();
        }
    }
}
catch (Return__ retValue)
{
    return retValue;
}

